package CBR;

import java.util.ArrayList;

public class Similarity {

	// initialise casebase object
	CaseBase CB = new CaseBase();

	// global similarity method
	public ArrayList<Double> globalSim(String currentSpe, String DeviantData1, String DeviantData2, String DeviantData3,
			String manualWork, String shackleStatus, String slopeDev, String WeatherCon) {
		double similarity = 0;

		ArrayList<Double> similarities = new ArrayList();
		ArrayList<Double> result = new ArrayList();

		CB.fillCase();

		double divSym = 0.0;

		for (int i = 0; i < CB.CaseBase.length; i++) {

			// checking whether attributes are unspecified
			if (!CB.CaseBase[i][0].equals("u")) {
				similarities.add(currentSpeSim(currentSpe, CB.CaseBase[i][0]));
			}

			if (!CB.CaseBase[i][1].equals("u")) {
				similarities.add(deviantDataSim(DeviantData1, CB.CaseBase[i][1]));
			}
			if (!CB.CaseBase[i][2].equals("u")) {
				similarities.add(deviantDataSim(DeviantData2, CB.CaseBase[i][2]));
			}
			if (!CB.CaseBase[i][3].equals("u")) {
				similarities.add(deviantDataSim(DeviantData3, CB.CaseBase[i][3]));
			}

			if (!CB.CaseBase[i][4].equals("u")) {
				similarities.add(manualWorkSim(manualWork, CB.CaseBase[i][4]));
			}

			if (!CB.CaseBase[i][5].equals("u")) {
				similarities.add(shackleStatusSim(shackleStatus, CB.CaseBase[i][5]));
			}

			if (!CB.CaseBase[i][6].equals("u")) {
				similarities.add(slopeDevSim(slopeDev, CB.CaseBase[i][6]));
			}

			if (!CB.CaseBase[i][7].equals("u")) {
				similarities.add(weatherConSim(WeatherCon, CB.CaseBase[i][7]));
			}

			divSym = 1.0 / similarities.size();

			for (Double value : similarities) {
				similarity += value * divSym;
			}

			result.add(similarity);

			similarity = 0;
			similarities.clear();

		}
		return result;
	}

	// calculate local similarities
	double currentSpeSim(String queryCurrentSpe, String caseCurrentSpe) {
		double similarity = 0;

		if (queryCurrentSpe.equals("high")) {
			similarity = 1.0;
		} else if (queryCurrentSpe.equals("medium")) {
			if (caseCurrentSpe.equals("high")) {
				similarity = 0.5;
			} else {
				similarity = 1.0;
			}
		} else {
			if (caseCurrentSpe.equals("low")) {
				similarity = 1.0;
			}
		}
		return similarity;
	}

	double deviantDataSim(String queryDeviantData, String caseDeviantData) {
		double similarity = 0;

		if (queryDeviantData.equals("over")) {
			if (caseDeviantData.equals("over")) {
				similarity = 1.0;
			}
		} else if (queryDeviantData.equals("under")) {
			if (caseDeviantData.equals("under")) {
				similarity = 1.0;
			}
		} else {
			if (caseDeviantData.equals("low")) {
				similarity = 1.0;
			}
		}
		return similarity;
	}

	double manualWorkSim(String queryManualWork, String caseManualWork) {
		double similarity = 0;

		if (queryManualWork.equals(caseManualWork)) {
			similarity = 1.0;
		}
		return similarity;
	}

	double shackleStatusSim(String queryShackleStatus, String caseShackleStatus) {
		double similarity = 0;

		if (queryShackleStatus.equals(caseShackleStatus)) {
			similarity = 1.0;
		}
		return similarity;
	}

	double slopeDevSim(String querySlopeDev, String caseSlopeDev) {
		double similarity = 0;

		if (querySlopeDev.equals(caseSlopeDev)) {
			similarity = 1.0;
		}
		return similarity;
	}

	double weatherConSim(String queryWeatherCon, String caseWeatherCon) {
		double similarity = 0;

		if (queryWeatherCon.equals("extreme")) {
			similarity = 1.0;
		} else if (queryWeatherCon.equals("bad")) {
			if (caseWeatherCon.equals("extreme")) {
				similarity = 0.5;
			} else {
				similarity = 1.0;
			}
		} else {
			if (caseWeatherCon.equals("good")) {
				similarity = 1.0;
			}
		}
		return similarity;
	}
}
