package dataAcquisition;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

public class ConvertData {

	// read and write weather data
	@SuppressWarnings("resource")
	public ArrayList<double[]> ReadWeather(String csvFile, int start) throws IOException {

		// initialise dataarrays
		double[] dataArr1 = new double[2];
		double[] dataArr2 = new double[2];
		double[] dataArr3 = new double[2];
		double[] dataArr4 = new double[2];

		BufferedReader br = null;
		String line = "";
		String cvsSplitBy = ",";
		int counter = 0;

		br = new BufferedReader(new FileReader(csvFile));
		while ((line = br.readLine()) != null) {

			// iterate and write data from two hours into the arrays
			if (counter >= start && counter < (start + dataArr1.length)) {
				String[] data = line.split(cvsSplitBy);

				dataArr1[counter - start] = Double.parseDouble(data[0]);
				dataArr2[counter - start] = Double.parseDouble(data[1]);
				dataArr3[counter - start] = Double.parseDouble(data[2]);
				dataArr4[counter - start] = Double.parseDouble(data[4]);
			}
			counter++;
		}

		ArrayList<double[]> weather = new ArrayList();
		weather.add(dataArr1);
		weather.add(dataArr2);
		weather.add(dataArr3);
		weather.add(dataArr4);
		return weather;
	}

	// read and write shackle data
	@SuppressWarnings("resource")
	public ArrayList<double[]> ReadShackles(String csvFile, int start) throws IOException {

		double[] dataArr1 = new double[120];
		double[] dataArr2 = new double[120];
		double[] dataArr3 = new double[120];

		BufferedReader br = null;
		String line = "";
		String cvsSplitBy = ",";
		int counter = 0;

		br = new BufferedReader(new FileReader(csvFile));
		while ((line = br.readLine()) != null) {

			if ((counter >= (start * 60)) && (counter < (start * 60 + dataArr1.length))) {
				String[] data = line.split(cvsSplitBy);
				dataArr1[counter - start * 60] = Double.parseDouble(data[0]);
				dataArr2[counter - start * 60] = Double.parseDouble(data[1]);
				dataArr3[counter - start * 60] = (Double.parseDouble(data[2]) * -1.0);
			}
			counter++;
		}

		ArrayList<double[]> shackle = new ArrayList();
		shackle.add(dataArr1);
		shackle.add(dataArr2);
		shackle.add(dataArr3);
		return shackle;
	}
}
