package dataInterpretation;

public class GetStatus {

	// calculate the status of the symptoms
	public String shackleStatus(double[] shackle1, double[] shackle2, double[] shackle3) {
		double max1t1 = 0;
		double max1t2 = 0;
		double max1t3 = 0;

		Calculations calculations = new Calculations();

		// calc max within 1 hour
		max1t1 = calculations.calcMax(shackle1, 1, false);
		max1t2 = calculations.calcMax(shackle2, 1, false);
		max1t3 = calculations.calcMax(shackle3, 1, false);
		String Broken = "good";

		if (max1t1 <= 0 || max1t2 <= 0 || max1t3 <= 0) {
			if (max1t1 <= 0) {
				Broken = "bad";
			}
			if (max1t2 <= 0) {
				Broken = "bad";
			}
			if (max1t3 <= 0) {
				Broken = "bad";
			}
		}
		return Broken;
	}

	public String weatherCondition(double wind, double wave) {
		String work = null;

		if (wind > 12 || wave > 1) {
			work = "extreme";
		} else if (wind > 7 || wave > 0.5) {
			work = "bad";
		} else {
			work = "good";
		}
		return work;
	}

	public String currentSpeed(double current) {
		String currentText = null;

		if (current < 8) {
			currentText = "low";
		} else if (current < 20) {
			currentText = "medium";
		} else {
			currentText = "high";
		}
		return currentText;
	}

	public String slopeDeviation(double[] data, double[] shackle1, double[] shackle2, double[] shackle3) {

		double dataSlope = 0;
		double shackleSlope1 = 0;
		double shackleSlope2 = 0;
		double shackleSlope3 = 0;

		double diff1 = 0;
		double diff2 = 0;
		double diff3 = 0;

		double threshold = 30;
		String failedSlopeShackles = "low";

		Calculations calculations = new Calculations();

		// calculate slope
		dataSlope = calculations.calcSlope(data, 2, true);
		shackleSlope1 = calculations.calcSlope(shackle1, 2, false);
		shackleSlope2 = calculations.calcSlope(shackle2, 2, false);
		shackleSlope3 = calculations.calcSlope(shackle3, 2, false);

		// calculate diff
		diff1 = Math.abs(Math.abs(dataSlope - shackleSlope1) / dataSlope * 100);
		diff2 = Math.abs(Math.abs(dataSlope - shackleSlope2) / dataSlope * 100);
		diff3 = Math.abs(Math.abs(dataSlope - shackleSlope3) / dataSlope * 100);

		if (diff1 > threshold) {
			failedSlopeShackles = "high";
		}
		if (diff2 > threshold) {
			failedSlopeShackles = "high";
		}
		if (diff3 > threshold) {
			failedSlopeShackles = "high";
		}
		return failedSlopeShackles;
	}

	// machine learning symptom
	public String deviationData(double[] currentSpeed, double[] currentDirection, double[] shackle, int shackleID)
			throws Exception {
		String deviation = "low";
		double pred;
		int overCounter = 0, underCounter = 0;
		double accuracy = 0.0, accuracyCounter = 0.0;

		// define threshold for the three classes for each shackle
		for (int i = 0; i < shackle.length / 2; i++) {
			if (shackleID == 85130) {
				if (shackle[i] > 0.085) {
					shackle[i] = 2.0;
				} else if (shackle[i] > 0.02) {
					shackle[i] = 1.0;
				} else {
					shackle[i] = 0.0;
				}
			} else if (shackleID == 99871) {
				if (shackle[i] > 0.225) {
					shackle[i] = 2.0;
				} else if (shackle[i] > 0.075) {
					shackle[i] = 1.0;
				} else {
					shackle[i] = 0.0;
				}
			} else {
				if (shackle[i] > 0.4) {
					shackle[i] = 2.0;
				} else if (shackle[i] > 0.01) {
					shackle[i] = 1.0;
				} else {
					shackle[i] = 0.0;
				}
			}

			// run the classifier
			pred = ML.run(currentSpeed[0], currentDirection[0], shackleID);
			if (pred == shackle[i]) {
				accuracyCounter++;
			} else if (pred > shackle[i]) {
				overCounter++;
			} else {
				underCounter++;
			}
		}

		// calculate the accuracy of the classification
		accuracy = accuracyCounter / 60;
		if (accuracy <= 0.8) {
			if (overCounter > underCounter) {
				deviation = "over";
			} else {
				deviation = "under";
			}

		}
		return deviation;
	}

}
