package dataInterpretation;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

import CBR.Similarity;
import GUI.Controller;
import dataAcquisition.ConvertData;

//create a thread to handle the iterations. Need a thread to be able to read files, update containers, update query and perform the similarity calculation at every iteration
public class PrepareQueryThread implements Runnable {

	public Thread t;
	private String threadName;
	boolean suspended = false;

	public PrepareQueryThread(String name) {
		threadName = name;
	}

	// create objects
	ConvertData FileReader = new ConvertData();
	dataInterpretation.GetStatus mergedSymptoms = new dataInterpretation.GetStatus();

	// initialise variables and arrays
	double[][] total = new double[2][4];

	double[] wind = new double[2];
	double[] wave = new double[2];
	double[] currentSpeed = new double[2];
	double[] currentDirection = new double[2];

	double[] shackle85130 = new double[120];
	double[] shackle99871 = new double[120];
	double[] shackle99875 = new double[120];

	ArrayList<double[]> shackles = new ArrayList();
	ArrayList<double[]> weather = new ArrayList();

	int timer = 0;

	public static String currentSpe, deviantData1, deviantData2, deviantData3, shackleStatus, slopeDev, WeatherCon;
	int counter = 0;

	// start thread when RUN PONTUS button is pushed.
	@Override
	public void run() {
		while (true) {
			// System.out.println("Running " + threadName);
			try {
				// br = new BufferedReader(new FileReader(csvFile));
				while (timer < 661) {
					// suspend so things can happen
					suspend();

					// read files and set values to use in query
					weather = FileReader.ReadWeather(System.getProperty("user.dir") + "/lib/weather.csv", timer);
					currentSpeed = weather.get(0);
					currentDirection = weather.get(1);
					wind = weather.get(2);
					wave = weather.get(3);

					shackles = FileReader.ReadShackles(System.getProperty("user.dir") + "/lib/shackles.csv", timer);

					shackle85130 = shackles.get(0);
					shackle99871 = shackles.get(1);
					shackle99875 = shackles.get(2);

					// set query to be ready for similarity calculation.
					shackleStatus = mergedSymptoms.shackleStatus(shackle85130, shackle99871, shackle99875);
					WeatherCon = mergedSymptoms.weatherCondition(wind[1], wave[1]);
					slopeDev = mergedSymptoms.slopeDeviation(currentSpeed, shackle85130, shackle99871, shackle99875);
					deviantData1 = mergedSymptoms.deviationData(currentSpeed, currentDirection, shackle85130, 85130);
					deviantData2 = mergedSymptoms.deviationData(currentSpeed, currentDirection, shackle99871, 99871);
					deviantData3 = mergedSymptoms.deviationData(currentSpeed, currentDirection, shackle99875, 99871);
					currentSpe = mergedSymptoms.currentSpeed(currentSpeed[1]);

					// iterate one hour
					timer++;

					// thread is resumed when similarity is calculated in other
					// class.

					Thread.sleep(300);
					synchronized (this) {
						while (suspended) {
							wait();
						}
					}
				}

			} catch (InterruptedException e) {
				System.out.println("Thread " + threadName + " interrupted");
			}

			catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void start() {
		// System.out.println("Starting " + threadName);
		if (t == null) {
			t = new Thread(this, threadName);
			t.start();
		}
	}

	public void suspend() {
		suspended = true;
	}

	public synchronized void resume() {
		suspended = false;
		notify();
	}

}
